Subject: bug#14831: cl-member warnings during bootstrap

From: Glenn Morris <[email-masked]>
Date: Mon, 15 Jul 2013 21:37:44 -0400

Stefan Monnier wrote:

> I'd like to understand exactly where those `cl-member's come from.
> I suspect the missing part is the (put 'cl-member 'compiler-macro
> #'cl--compiler-macro-member) which is normally in cl-loaddefs.el.
>
> Those residual cl-member calls may actually be a real problem, so maybe
> this is not just a minor cosmetic fix.

Deleting cl-loadefs.el and batch byte-compiling a file with sole contents:

(defvar foo-bar nil)
(add-to-list 'foo-bar 1)

produces byte-code containing cl-member. Makes no sense to me...

You are correct that adding

(eval-and-compile (put 'cl-member 'compiler-macro#'cl--compiler-macro-member))

to the start of the file seems to fix it.